/////////////////////////////////////////// Plot - Macro.h (mwx,07.09.06) /////
#import <Cocoa/Cocoa.h>
@class Manager;
@class PlotDocument;
@class PlotView;
@class DataBuffer;
@class Expression;

@interface Macro : NSObject <NSCoding> {
	@public
	NSMutableString *name,*src,*inlineperl;             // macro name and content
	int shortcut;                                               // macro shortcut
	int colormode;                                             // macro colormode
	int type;                                                       // macro type

	NSMutableArray *CMD;                                        // commmand array
	NSMutableArray *B;                                     // buffer option array
	NSMutableArray *A;                                       // axis option array
	NSMutableArray *R;                                      // range option array
	double D[16];                                          // double option array
	int I[16];                                            // integer option array
	BOOL O[16];                                            // option exists array
	NSMutableArray *S,*SS;                // string & orginal string option array

	Manager *M;                                            // connections to Plot
	PlotDocument *PD;
	PlotView *PV;
	DataBuffer *DB;

	BOOL OK;                                                   // command ok flag
	int ERR;                                                       // error count
	BOOL CANCEL;                                              // macro abort flag

	BOOL LOOPNEXT;                                                   // loop data
	NSMutableArray *LOOP;
	int LOOPSTART;
	double LOOPVAL;
	int LOOPMODE,LOOPBUFFER;

	BOOL IFMODE,IFCOND;                                     // if,ele, endif data

	double th,tw;                                          // text width & height

	double defr,defg,defb;                                       // default color
	NSMutableString *deffont;                                     // default font
	double deffontsize;

}

- (id)init;
- (id)initWithSrc:(NSString *)aname:(NSString *)asrc:(int)ashortcut:(int)atype;
- (void)loadFromFile:(NSString *)path;
- (void)dealloc;
- (NSMutableString *)name;
- (NSMutableString *)src;
- (int)shortcut;
- (int)macrotype;
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
- (NSColor *)getColor:(double)a:(double)b:(double)c;
- (NSColor *)getColor:(double)a:(double)b:(double)c:(double)al;
- (void)parseMacro;
- (void)parseMacroFor:(PlotDocument *)pd;
- (void)perlFilter;
- (void)perlImport;
- (void)perlFilterFromMacro:(NSIndexSet *)buffer;
- (void)perlImportFromMacro:(NSString *)file;
- (void)perlFilter:(NSIndexSet *)buffer;
- (void)perlImport:(NSString *)file;
- (void)sendVariables:(NSMutableData *)idata;
- (void)parsePerlResult:(int)exitStatus:(NSData *)data:
		(NSString *)info:(NSString *)logfile;
- (void)executeMacro;
- (BOOL)chk:(NSString *)cmd:(NSString *)opt:(int)mo:(NSArray *)cmds;
- (BOOL)expr:(NSString *)expr:(int)no:(BOOL)showerr;
- (double)exprval:(NSString *)expr:(BOOL)showerr;
- (void)setupexpr:(Expression *)E;

@end ///////////////////////////////////////////////////////////////////// END
